Index: /extensions/UserCollections/admin.php
===================================================================
--- /extensions/UserCollections/admin.php	(revision 20090)
+++ /extensions/UserCollections/admin.php	(revision 20090)
@@ -0,0 +1,39 @@
+<?php
+if (!defined('USER_COLLEC_PATH')) die('Hacking attempt!');
+
+global $template, $page, $conf;
+
+
+// tabsheet
+include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
+$page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : 'sets';
+  
+$tabsheet = new tabsheet();
+$tabsheet->add('sets', l10n('Collections'), USER_COLLEC_ADMIN . '-sets');
+if ($page['tab'] == 'export')
+{
+  if (isset($_GET['col_id']))
+  {
+    $tabsheet->add('export', l10n('Export'), USER_COLLEC_ADMIN . '-export&amp;col_id='.$_GET['col_id']);
+  }
+  else
+  {
+    $page['tab'] = 'sets';
+  }
+}
+$tabsheet->add('config', l10n('Configuration'), USER_COLLEC_ADMIN . '-config');
+$tabsheet->select($page['tab']);
+$tabsheet->assign();
+
+// include page
+include(USER_COLLEC_PATH . 'admin/' . $page['tab'] . '.php');
+
+// template
+$template->assign(array(
+  'USER_COLLEC_PATH' => USER_COLLEC_PATH,
+  'USER_COLLEC_ADMIN' => USER_COLLEC_ADMIN,
+  ));
+  
+$template->assign_var_from_handle('ADMIN_CONTENT', 'user_collections');
+
+?>
Index: /extensions/UserCollections/admin/config.php
===================================================================
--- /extensions/UserCollections/admin/config.php	(revision 20090)
+++ /extensions/UserCollections/admin/config.php	(revision 20090)
@@ -0,0 +1,21 @@
+<?php
+if (!defined('USER_COLLEC_PATH')) die('Hacking attempt!');
+
+if (isset($_POST['save_config']))
+{
+  $conf['user_collections'] = array(
+    'allow_mails'     => isset($_POST['allow_mails']),
+    'allow_public'    => isset($_POST['allow_public']),
+    );
+  
+  conf_update_param('user_collections', serialize($conf['user_collections']));
+}
+
+$template->assign(array(
+  'user_collections' => $conf['user_collections'],
+  ));
+
+
+$template->set_filename('user_collections', dirname(__FILE__) . '/template/config.tpl');
+
+?>
Index: /extensions/UserCollections/admin/export.php
===================================================================
--- /extensions/UserCollections/admin/export.php	(revision 20090)
+++ /extensions/UserCollections/admin/export.php	(revision 20090)
@@ -0,0 +1,36 @@
+<?php
+if (!defined('USER_COLLEC_PATH')) die('Hacking attempt!');
+
+try {
+  $UserCollection = new UserCollection($_GET['col_id']);
+  
+  $template->assign('COL_ID', $_GET['col_id']);
+}
+catch (Exception $e)
+{
+  array_push($page['errors'], $e->getMessage());
+}
+
+
+if (isset($_POST['download']))
+{
+  $content = $UserCollection->serialize($_POST['content']);
+  $filename = 'collection_'.$_GET['col_id'].'_'.date('Ymd-Hi').'.csv';
+  
+  header('Content-Type: application/force-download; name="'.$filename.'"');
+  header('Content-Disposition: attachment; filename="'.$filename.'"');
+  header('Content-Description: File Transfer');
+  header('Content-Transfer-Encoding: binary');
+  header('Content-Length: '.strlen($content).'');
+
+  header('Cache-Control: no-cache, must-revalidate');
+  header('Pragma: no-cache');
+  header('Expires: 0');
+  
+  echo $content;
+  exit;
+}
+
+$template->set_filename('user_collections', dirname(__FILE__) . '/template/export.tpl');
+
+?>
Index: /extensions/UserCollections/admin/index.php
===================================================================
--- /extensions/UserCollections/admin/index.php	(revision 20090)
+++ /extensions/UserCollections/admin/index.php	(revision 20090)
@@ -0,0 +1,30 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | Piwigo - a PHP based photo gallery                                    |
+// +-----------------------------------------------------------------------+
+// | Copyright(C) 2008-2012 Piwigo Team                  http://piwigo.org |
+// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
+// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// Recursive call
+$url = '../';
+header( 'Request-URI: '.$url );
+header( 'Content-Location: '.$url );
+header( 'Location: '.$url );
+exit();
+?>
Index: /extensions/UserCollections/admin/sets.php
===================================================================
--- /extensions/UserCollections/admin/sets.php	(revision 20090)
+++ /extensions/UserCollections/admin/sets.php	(revision 20090)
@@ -0,0 +1,90 @@
+<?php
+if (!defined('USER_COLLEC_PATH')) die('Hacking attempt!');
+
+// actions
+if (isset($_GET['delete']))
+{
+  pwg_query('DELETE FROM '.COLLECTIONS_TABLE.' WHERE id = '.$_GET['delete'].';');
+  pwg_query('DELETE FROM '.COLLECTION_IMAGES_TABLE.' WHERE col_id = '.$_GET['delete'].';');
+}
+
+// filter
+$where_clauses = array('1=1');
+$order_by = 'date_creation DESC, name ASC';
+
+if (isset($_POST['filter']))
+{
+  if (!empty($_POST['username']))
+  {
+    array_push($where_clauses, 'username LIKE "%'.$_POST['username'].'%"');
+  }
+  
+  if (!empty($_POST['name']))
+  {
+    array_push($where_clauses, 'name LIKE "%'.$_POST['name'].'%"');
+  }
+  
+  $order_by = $_POST['order_by'].' '.$_POST['direction'];
+}
+
+
+// get sets
+$query = '
+SELECT 
+    c.*,
+    u.'.$conf['user_fields']['username'].' AS username
+  FROM '.COLLECTIONS_TABLE.' AS c
+    INNER JOIN '.USERS_TABLE.' AS u
+    ON c.user_id = u.'.$conf['user_fields']['id'].'
+  WHERE
+    '.implode("\n    AND ", $where_clauses).'
+  ORDER BY '.$order_by.'
+;';
+$sets = hash_from_query($query, 'id');
+
+foreach ($sets as $row)
+{
+  $template->append('sets', array(
+    'NAME' => $row['name'],
+    'NB_IMAGES' => $row['nb_images'],
+    'DATE_CREATION' => format_date($row['date_creation'], true),
+    'USERNAME' => $row['username'],
+    'IS_PUBLIC' => (bool)$row['public'],
+    'U_PUBLIC' => USER_COLLEC_PUBLIC . 'view/'.$row['public_id'],
+    'U_EDIT' => USER_COLLEC_PUBLIC . 'edit/'.$row['id'],
+    'U_EXPORT' => USER_COLLEC_ADMIN . '-export&amp;col_id='.$row['id'],
+    'U_DELETE' => USER_COLLEC_ADMIN . '-sets&amp;delete='.$row['id'],
+    ));
+}
+
+
+// filter options
+$page['order_by_items'] = array(
+  'date_creation' => l10n('Creation date'),
+  'nb_images' => l10n('Number of images'),
+  );
+
+$page['direction_items'] = array(
+  'DESC' => l10n('descending'),
+  'ASC' => l10n('ascending'),
+  );
+
+$template->assign('order_options', $page['order_by_items']);
+$template->assign('order_selected',
+    isset($_POST['order_by']) ? $_POST['order_by'] : '');
+
+$template->assign('direction_options', $page['direction_items']);
+$template->assign('direction_selected',
+    isset($_POST['direction']) ? $_POST['direction'] : '');
+
+
+$template->assign(array(
+  'F_USERNAME' => @htmlentities($_POST['username'], ENT_COMPAT, 'UTF-8'),
+  'F_NAME' => @htmlentities($_POST['name'], ENT_COMPAT, 'UTF-8'),
+  'F_FILTER_ACTION' => USER_COLLEC_ADMIN . '-sets',
+  ));
+
+
+$template->set_filename('user_collections', dirname(__FILE__) . '/template/sets.tpl');
+
+?>
Index: /extensions/UserCollections/include/UserCollection.class.php
===================================================================
--- /extensions/UserCollections/include/UserCollection.class.php	(revision 20089)
+++ /extensions/UserCollections/include/UserCollection.class.php	(revision 20090)
@@ -12,11 +12,15 @@
    * @param: array images
    */
-  function __construct($col_id, $images=array(), $name=null, $active=false, $public=false)
+  function __construct($col_id, $images=array(), $name=null, $active=false, $public=false, $user_id=null)
   {
     global $user;
+    
+    if (empty($user_id)) {
+      $user_id = $user['id'];
+    }
     
     $this->data = array(
       'id' => 0,
-      'user_id' => $user['id'],
+      'user_id' => $user_id,
       'name' => null,
       'date_creation' => '0000-00-00 00:00:00',
@@ -28,5 +32,5 @@
     $this->images = array();
     
-    // access from public id
+    // access from public id (access permission is checked line 66)
     if ( strlen($col_id) == 10 and strpos($col_id, 'uc') === 0 )
     {
@@ -84,4 +88,5 @@
         pwg_query($query);
       
+        // select images of the collection
         $query = '
 SELECT image_id
@@ -91,8 +96,5 @@
         $this->images = array_from_query($query, 'image_id');
         
-        if ($this->data['nb_images'] != count($this->images))
-        {
-          $this->updateParam('nb_images', count($this->images));
-        }
+        $this->updateParam('nb_images', count($this->images));
       }
       else
@@ -130,5 +132,5 @@
       $this->data['id'] = pwg_db_insert_id();
       
-      $date = pwg_query('SELECT FROM_UNIXTIME(NOW());');
+      $date = pwg_query('SELECT NOW();');
       list($this->data['date_creation']) = pwg_db_fetch_row($date);
       
@@ -164,6 +166,9 @@
   function updateParam($name, $value)
   {
-    $this->data[$name] = $value;
-    pwg_query('UPDATE '.COLLECTIONS_TABLE.' SET '.$name.' = "'.$value.'" WHERE id = '.$this->data['id'].';');
+    if ($value != $this->data[$name])
+    {
+      $this->data[$name] = $value;
+      pwg_query('UPDATE '.COLLECTIONS_TABLE.' SET '.$name.' = "'.pwg_db_real_escape_string($value).'" WHERE id = '.$this->data['id'].';');
+    }
   }
   
@@ -246,4 +251,14 @@
       );
       
+    $query = '
+UPDATE '.COLLECTION_IMAGES_TABLE.'
+  SET add_date = NOW()
+  WHERE
+    col_id = '.$this->data['id'].'
+    AND image_id IN ('.implode(',', $image_ids).')
+    AND add_date IS NULL
+';
+    pwg_query($query);
+      
     $this->updateParam('nb_images', count($this->images));
   }
@@ -291,5 +306,5 @@
       'ACTIVE' => (bool)$this->data['active'],
       'PUBLIC' => (bool)$this->data['public'],
-      'DATE_CREATION' => format_date($this->data['date_creation'], true),
+      'DATE_CREATION' => $this->data['date_creation'],
       'U_PUBLIC' => USER_COLLEC_PUBLIC . 'view/'.$this->data['public_id'],
       'IS_TEMP' =>  $this->data['name'] == 'temp',
@@ -298,4 +313,257 @@
     return $set;
   }
+  
+  /**
+   * Send the collection by email
+   * @param: array
+   *          - sender_name
+   *          - sender_email
+   *          - recipient_email
+   *          - recipient_name
+   *          - nb_images
+   *          - message
+   * @return: array errors
+   */
+  function sendEmail($comm, $key)
+  {
+    global $conf, $page, $template;
+    
+    $errors = array();
+    
+    $comm = array_map('stripslashes', $comm);
+
+    $comment_action='validate';
+    
+    // check key
+    if (!verify_ephemeral_key(@$key))
+    {
+      array_push($errors, l10n('Invalid or expired security key'));
+      $comment_action='reject';
+    }
+
+    // check author
+    if (empty($comm['sender_name']))
+    {
+      array_push($errors, l10n('Please enter your name'));
+      $comment_action='reject';
+    }      
+    if (empty($comm['recipient_name']))
+    {
+      array_push($errors, l10n('Please enter the recipient name'));
+      $comment_action='reject';
+    }
+    
+    // check email
+    if (empty($comm['sender_email']))
+    {
+      array_push($errors, l10n('Please enter your e-mail'));
+      $comment_action='reject';
+    }
+    else if ( !empty($comm['sender_email']) and !uc_check_email_validity($comm['sender_email']) )
+    {
+      array_push($errors, l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)'));
+      $comment_action='reject';
+    }
+    if (empty($comm['recipient_email']))
+    {
+      array_push($errors, l10n('Please enter the recipient e-mail'));
+      $comment_action='reject';
+    }
+    else if ( !empty($comm['recipient_email']) and !uc_check_email_validity($comm['recipient_email']) )
+    {
+      array_push($errors, l10n('mail address must be like xxx@yyy.eee (example : jack@altern.org)'));
+      $comment_action='reject';
+    }
+     
+    // check content
+    if (!empty($comm['message']))
+    {
+      $comm['message'] = nl2br($comm['message']);
+    }
+    
+    include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
+    
+    if ($comment_action == 'validate')
+    {
+      // format subject
+      $subject = '['.$conf['gallery_title'].'] '.sprintf(l10n('A photo collection by %s'), $comm['sender_name']);
+      $subject = encode_mime_header($subject);
+            
+      // format expeditor
+      $args['from'] = format_email($comm['sender_name'], $comm['sender_email']);
+      $args['to'] = format_email($comm['recipient_name'], $comm['recipient_email']);
+      
+      // hearders
+      $headers = 'From: '.$args['from']."\n";  
+      $headers.= 'MIME-Version: 1.0'."\n";
+      $headers.= 'X-Mailer: Piwigo Mailer'."\n";
+      $headers.= 'Content-Transfer-Encoding: 8bit'."\n";
+      $headers.= 'Content-Type: text/html; charset="'.get_pwg_charset().'";'."\n";
+            
+      // mail content
+      $content = $this->getMailContent($comm);
+      $content = wordwrap($content, 70, "\n", true);
+      
+      // send mail
+      $result =
+        trigger_event('send_mail',
+          false, /* Result */
+          trigger_event('send_mail_to', $args['to']),
+          trigger_event('send_mail_subject', $subject),
+          trigger_event('send_mail_content', $content),
+          trigger_event('send_mail_headers', $headers),
+          $args
+        );
+      
+      if ($result == false)
+      {
+        $_SESSION['page_errors'][] = l10n('Error while sending e-mail');
+      }
+      else
+      {
+        $_SESSION['page_infos'][] = l10n('E-mail sent successfully');
+      }
+      
+      redirect();
+    }
+    
+    return $errors;
+  }
+  
+  /**
+   * get mail content for sendMail()
+   */
+  function getMailContent($params)
+  {
+    global $user, $conf, $template;
+    
+    // switch to guest user
+    $user_save = $user;
+    $user = build_user($conf['guest_id'], true);
+    
+    // get pictures
+    $query = '
+SELECT
+    id,
+    file,
+    name,
+    path
+  FROM '.IMAGES_TABLE.' AS i
+    JOIN '.IMAGE_CATEGORY_TABLE.' AS ci ON ci.image_id = i.id
+  WHERE id IN ('.implode(',', $this->images).')
+    '.get_sql_condition_FandF(array(
+                'forbidden_categories' => 'category_id',
+                'forbidden_images' => 'id'
+                ),
+              'AND'
+              ).'
+  GROUP BY i.id
+  ORDER BY '.DB_RANDOM_FUNCTION.'()
+  LIMIT '.$params['nb_images'].'
+;';
+    $pictures = hash_from_query($query, 'id');
+    
+    // switch back to current user
+    $user = $user_save;
+    unset($user_save);
+  
+    // picture sinfos
+    set_make_full_url();
+    $tpl_vars = array();
+    foreach ($pictures as $row)
+    {
+      $name = render_element_name($row);
+      
+      $tpl_vars[] = array(
+        'TN_ALT' => htmlspecialchars(strip_tags($name)),
+        'NAME' => $name,
+        'URL' => make_picture_url(array('image_id' => $row['id'])),
+        'THUMB' => DerivativeImage::url(IMG_SQUARE, $row),
+        );
+    }
+    
+    // template
+    $mail_css = file_get_contents(dirname(__FILE__).'/../template/mail.css');
+    
+    $template->assign(array(
+      'GALLERY_URL' => get_gallery_home_url(),
+      'PHPWG_URL' => PHPWG_URL,
+      'UC_MAIL_CSS' => str_replace("\n", null, $mail_css),
+      'MAIL_TITLE' => $this->getParam('name').' ('.sprintf(l10n('by %s'), $params['sender_name']).')',
+      'COL_URL' => USER_COLLEC_PUBLIC . 'view/'.$this->data['public_id'],
+      'PARAMS' => $params,
+      'derivative_params' => ImageStdParams::get_by_type(IMG_SQUARE),
+      'thumbnails' => $tpl_vars,
+      ));
+      
+    $template->set_filename('uc_mail', dirname(__FILE__).'/../template/mail.tpl');
+    $content = $template->parse('uc_mail', true);
+  
+    unset_make_full_url();
+    
+    return $content;
+  }
+
+  /**
+   * generate a listing of the collection
+   */
+  function serialize($params)
+  {      
+    $content = null;
+     
+    // get images infos
+    $query = '
+SELECT
+    id,
+    file,
+    name,
+    path
+  FROM '.IMAGES_TABLE.'
+  WHERE id IN('.implode(',', $this->images).')
+  ORDER BY id
+;';
+    $pictures = hash_from_query($query, 'id');
+    
+    if (count($pictures))
+    {
+      // generate csv
+      set_make_full_url();
+      $root_url = get_root_url();
+      
+      $fp = fopen('php://temp', 'r+');
+      foreach ($pictures as $row)
+      {
+        $element = array();
+        foreach ($params as $field)
+        {
+          switch ($field)
+          {
+          case 'id':
+            $element[] = $row['id']; break;
+          case 'file':
+            $element[] = $row['file']; break;
+          case 'name':
+            $element[] = render_element_name($row); break;
+          case 'url':
+            $element[] = make_picture_url(array('image_id'=>$row['id'], 'image_file'=>$row['file'])); break;
+          case 'path':
+            $element[] = $root_url.ltrim($row['path'], './'); break;
+          }
+        }
+        if (!empty($element))
+        {
+          fputcsv($fp, $element);
+        }
+      }
+      
+      rewind($fp);
+      $content = stream_get_contents($fp);
+      fclose($fp);
+      
+      unset_make_full_url();
+    }
+    
+    return $content;
+  }
 }
 
Index: /extensions/UserCollections/include/collections.inc.php
===================================================================
--- /extensions/UserCollections/include/collections.inc.php	(revision 20089)
+++ /extensions/UserCollections/include/collections.inc.php	(revision 20090)
@@ -159,4 +159,5 @@
     $self_url = USER_COLLEC_PUBLIC . 'edit/'.$page['col_id'];
     $template->assign(array(
+      'user_collections' => $conf['user_collections'],
       'USER_COLLEC_PATH' => USER_COLLEC_PATH,
       'F_ACTION' => $self_url,
@@ -184,7 +185,45 @@
         else
         {
-          $UserCollection->updateParam('name', $_POST['name']);
+          $UserCollection->updateParam('name', stripslashes($_POST['name']));
+        }
+        if (!$conf['user_collections']['allow_public'])
+        {
+          $_POST['public'] = '0';
         }
         $UserCollection->updateParam('public', $_POST['public']);
+      }
+      
+      // send mail
+      if ( $conf['user_collections']['allow_public'] and $conf['user_collections']['allow_mails'] )
+      {
+        $contact = array(
+            'sender_name' => $user['username'],
+            'sender_email' => $user['email'],
+            'recipient_name' => null,
+            'recipient_email' => null,
+            'nb_images' => 4,
+            'message' => null,
+            );
+            
+        if ( isset($_POST['send_mail']) and (bool)$UserCollection->getParam('public') )
+        {
+          $contact = array(
+            'sender_email' => trim($_POST['sender_email']),
+            'sender_name' => trim($_POST['sender_name']),
+            'recipient_email' => trim($_POST['recipient_email']),
+            'recipient_name' => trim($_POST['recipient_name']),
+            'nb_images' => $_POST['nb_images'],
+            'message' => $_POST['message'],
+            );
+            
+          $errors = $UserCollection->sendEmail($contact, @$_POST['key']);
+          if (count($errors))
+          {
+            $template->assign('uc_mail_errors', $errors);
+          }
+        }
+        
+        $contact['KEY'] = get_ephemeral_key(3);
+        $template->assign('contact', $contact);
       }
       
@@ -202,32 +241,38 @@
       }
       
-      // special template
-      add_event_handler('loc_end_index_thumbnails', 'user_collections_thumbnails_in_collection', EVENT_HANDLER_PRIORITY_NEUTRAL+10, 2); // +10 to overload GThumb+
+      // add links for colorbox
+      add_event_handler('loc_end_index_thumbnails', 'user_collections_thumbnails_in_collection', EVENT_HANDLER_PRIORITY_NEUTRAL, 2);
+      
+      // add remove item links
       $template->set_prefilter('index_thumbnails', 'user_collections_thumbnails_list_prefilter');
       
       // collection content
       $col = $UserCollection->getCollectionInfo();
+      $col['DATE_CREATION'] = format_date($col['DATE_CREATION'], true);
       $col['U_CLEAR'] = $self_url.'&amp;action=clear';
       $col['U_DELETE'] = add_url_params(USER_COLLEC_PUBLIC, array('action'=>'delete','col_id'=>$page['col_id']));
       $template->assign('collection', $col);
-      
       $page['items'] = $UserCollection->getImages();
       
-      // navigation bar
-      $page['start'] = isset($_GET['start']) ? $_GET['start'] : 0;
-      if (count($page['items']) > $page['nb_image_page'])
-      {
-        $page['navigation_bar'] = create_navigation_bar(
-          $self_url,
-          count($page['items']),
-          $page['start'],
-          $page['nb_image_page'],
-          false
-          );
-        $template->assign('navbar', $page['navigation_bar']);
-      }
-      
-      // display
-      include(PHPWG_ROOT_PATH . 'include/category_default.inc.php');
+      // toolbar buttons
+      $buttons = null;
+      if ($conf['user_collections']['allow_public'] and $conf['user_collections']['allow_mails'])
+      {
+        $buttons.= '<li><a class="mail_colorbox_open" href="#mail_form" title="'.l10n('Send this collection my mail').'" class="pwg-state-default pwg-button" rel="nofollow" '.(!$col['PUBLIC']?'onClick="alert(\''.l10n('The collection must be public in order to send it').'\');return false;"':null).'>
+          <span class="pwg-icon user-collections-delete-icon" style="background:url(\'' . get_root_url().USER_COLLEC_PATH . 'template/resources/mail.png\') center center no-repeat;">&nbsp;</span><span class="pwg-button-text">'.l10n('Send').'</span>
+        </a></li>';
+      }
+      $buttons.= '
+        <li><a href="'. $col['U_CLEAR'] .'" title="'.l10n('Clear this collection').'" class="pwg-state-default pwg-button" rel="nofollow" onClick="return confirm(\''.l10n('Are you sure?').'\');">
+          <span class="pwg-icon user-collections-delete-icon" style="background:url(\'' . get_root_url().USER_COLLEC_PATH . 'template/resources/bin.png\') center center no-repeat;">&nbsp;</span><span class="pwg-button-text">'.l10n('Clear').'</span>
+        </a></li>
+        <li><a href="'. $col['U_DELETE'] .'" title="'.l10n('Delete this collection').'" class="pwg-state-default pwg-button" rel="nofollow" onClick="return confirm(\''.l10n('Are you sure?').'\');">
+          <span class="pwg-icon user-collections-delete-icon" style="background:url(\'' . get_root_url().USER_COLLEC_PATH . 'template/resources/delete.png\') center center no-repeat;">&nbsp;</span><span class="pwg-button-text">'.l10n('Delete').'</span>
+        </a></li>';
+      $template->concat('COLLECTION_ACTIONS', $buttons);
+      
+      // thumbnails
+      define('USER_COLLEC_REMOVE_GTHUMB', true);
+      include(USER_COLLEC_PATH . '/include/display_thumbnails.inc.php');
       
       $template->concat('TITLE', $conf['level_separator'].$UserCollection->getParam('name'));
@@ -245,5 +290,5 @@
   {
     // security
-    if ( empty($page['col_id']) or strlen($page['col_id']) != 10 or strpos($page['col_id'], 'uc') === false )
+    if ( empty($page['col_id']) or strlen($page['col_id']) != 10 or strpos($page['col_id'], 'uc') === false or !$conf['user_collections']['allow_public'] )
     {
       $_SESSION['page_errors'][] = l10n('Invalid collection');
@@ -257,28 +302,10 @@
     try {
       $UserCollection = new UserCollection($page['col_id']);
-      
-      // special template
-      add_event_handler('loc_end_index_thumbnails', 'user_collections_thumbnails_in_collection', EVENT_HANDLER_PRIORITY_NEUTRAL+10, 2); // +10 to overload GThumb+
-      
-      // collection content
       $page['items'] = $UserCollection->getImages();
       
-      // navigation bar
-      $page['start'] = isset($_GET['start']) ? $_GET['start'] : 0;
-      if (count($page['items']) > $page['nb_image_page'])
-      {
-        $page['navigation_bar'] = create_navigation_bar(
-          $self_url,
-          count($page['items']),
-          $page['start'],
-          $page['nb_image_page'],
-          false
-          );
-        $template->assign('navbar', $page['navigation_bar']);
-      }
-      
-      // display
-      include(PHPWG_ROOT_PATH . 'include/category_default.inc.php');
-      
+      // thumbnails
+      include(USER_COLLEC_PATH . '/include/display_thumbnails.inc.php');
+      
+      // add username in title
       include_once(PHPWG_ROOT_PATH.'admin/include/functions.php');
       $template->concat('TITLE', 
@@ -295,4 +322,5 @@
   }
 }
+
 
 $template->assign(array(
Index: /extensions/UserCollections/include/display_thumbnails.inc.php
===================================================================
--- /extensions/UserCollections/include/display_thumbnails.inc.php	(revision 20090)
+++ /extensions/UserCollections/include/display_thumbnails.inc.php	(revision 20090)
@@ -0,0 +1,54 @@
+<?php
+defined('USER_COLLEC_PATH') or die('Hacking attempt!');
+
+if (defined('USER_COLLEC_REMOVE_GTHUMB'))
+{
+  global $uc_nb_image_page_save;
+
+  $user['nb_image_page'] = $uc_nb_image_page_save['user'];
+  $page['nb_image_page'] = $uc_nb_image_page_save['page'];
+  remove_event_handler('loc_end_index_thumbnails', 'process_GThumb', 50);
+  remove_event_handler('loc_end_index', 'GThumb_remove_thumb_size');
+}
+
+// navigation bar
+$page['start'] = isset($_GET['start']) ? $_GET['start'] : 0;
+if (count($page['items']) > $page['nb_image_page'])
+{
+  $page['navigation_bar'] = create_navigation_bar(
+    $self_url,
+    count($page['items']),
+    $page['start'],
+    $page['nb_image_page'],
+    false
+    );
+  $template->assign('navbar', $page['navigation_bar']);
+}
+
+// display
+include(PHPWG_ROOT_PATH . 'include/category_default.inc.php');
+
+// multisize link
+$url = add_url_params(
+    $self_url,
+    array('display' => '')
+  );
+  
+$selected_type = $template->get_template_vars('derivative_params')->type;
+$template->clear_assign( 'derivative_params' );
+$type_map = ImageStdParams::get_defined_type_map();
+unset($type_map[IMG_XXLARGE], $type_map[IMG_XLARGE]);
+
+foreach($type_map as $params)
+{
+  $template->append(
+    'image_derivatives',
+    array(
+      'DISPLAY' => l10n($params->type),
+      'URL' => $url.$params->type,
+      'SELECTED' => ($params->type == $selected_type ? true:false),
+      )
+    );
+}
+  
+?>
Index: /extensions/UserCollections/include/events.inc.php
===================================================================
--- /extensions/UserCollections/include/events.inc.php	(revision 20089)
+++ /extensions/UserCollections/include/events.inc.php	(revision 20090)
@@ -3,4 +3,13 @@
 
 # this file contains all functions directly called by the triggers #
+
+/* compatibility fix with Gthumb+ */
+function user_collections_save_pagination()
+{
+  global $user, $page, $uc_nb_image_page_save;
+   
+  $uc_nb_image_page_save['user'] = $user['nb_image_page'];
+  $uc_nb_image_page_save['page'] = $page['nb_image_page'];
+}
 
 
@@ -122,7 +131,7 @@
 {strip}<a class="addCollection" href="{$collection_toggle_url}{$thumbnail.id}" data-id="{$thumbnail.id}" rel="nofollow">
 {if $COL_ID or $thumbnail.COLLECTION_SELECTED}
-{\'Remove from collection\'|@translate}&nbsp;<img src="{$ROOT_URL}{$USER_COLLEC_PATH}template/image_delete.png" title="{\'Remove from collection\'|@translate}">
+{\'Remove from collection\'|@translate}&nbsp;<img src="{$ROOT_URL}{$USER_COLLEC_PATH}template/resources/image_delete.png" title="{\'Remove from collection\'|@translate}">
 {else}
-{\'Add to collection\'|@translate}&nbsp;<img src="{$ROOT_URL}{$USER_COLLEC_PATH}template/image_add.png" title="{\'Add to collection\'|@translate}">
+{\'Add to collection\'|@translate}&nbsp;<img src="{$ROOT_URL}{$USER_COLLEC_PATH}template/resources/image_add.png" title="{\'Add to collection\'|@translate}">
 {/if}
 </a>{/strip}';
Index: /extensions/UserCollections/include/functions.inc.php
===================================================================
--- /extensions/UserCollections/include/functions.inc.php	(revision 20089)
+++ /extensions/UserCollections/include/functions.inc.php	(revision 20090)
@@ -32,3 +32,23 @@
 }
 
+function uc_check_email_validity($mail_address)
+{
+  if (function_exists('email_check_format'))
+  {
+    return email_check_format($mail_address); // Piwigo 2.5
+  }
+  else if (version_compare(PHP_VERSION, '5.2.0') >= 0)
+  {
+    return filter_var($mail_address, FILTER_VALIDATE_EMAIL)!==false;
+  }
+  else
+  {
+    $atom   = '[-a-z0-9!#$%&\'*+\\/=?^_`{|}~]';   // before  arobase
+    $domain = '([a-z0-9]([-a-z0-9]*[a-z0-9]+)?)'; // domain name
+    $regex = '/^' . $atom . '+' . '(\.' . $atom . '+)*' . '@' . '(' . $domain . '{1,63}\.)+' . $domain . '{2,63}$/i';
+
+    return (bool)preg_match($regex, $mail_address);
+  }
+}
+
 ?>
Index: /extensions/UserCollections/include/install.inc.php
===================================================================
--- /extensions/UserCollections/include/install.inc.php	(revision 20089)
+++ /extensions/UserCollections/include/install.inc.php	(revision 20090)
@@ -5,4 +5,15 @@
 {
   global $conf, $prefixeTable;
+  
+  if (empty($conf['user_collections']))
+  {
+    $default_config = serialize(array(
+      'allow_mails' => true,
+      'allow_public' => true,
+      ));
+      
+    conf_update_param('user_collections', $default_config);
+    $conf['user_collections'] = $default_config;
+  }
   
   // create tables
@@ -26,8 +37,15 @@
   `col_id` mediumint(8) NOT NULL,
   `image_id` mediumint(8) NOT NULL,
+  `add_date` DATETIME NULL,
   UNIQUE KEY `UNIQUE` (`col_id`,`image_id`)
 ) DEFAULT CHARSET=utf8
 ;';
   pwg_query($query);
+  
+  $result = pwg_query('SHOW COLUMNS FROM `'.$prefixeTable.'collection_images` LIKE "add_date";');
+  if (!pwg_db_num_rows($result))
+  {
+    pwg_query('ALTER TABLE `'.$prefixeTable.'collection_images` ADD `add_date` DATETIME NULL;');
+  }
 }
 
